/**
 * 
 */
package org.richfaces;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.richfaces.test.AbstractFacesTest;
import org.richfaces.test.LocalWebClient;
import org.w3c.dom.Element;

import com.gargoylesoftware.htmlunit.BrowserVersion;
import com.gargoylesoftware.htmlunit.NicelyResynchronizingAjaxController;
import com.gargoylesoftware.htmlunit.WebClient;
import com.gargoylesoftware.htmlunit.html.HtmlForm;
import com.gargoylesoftware.htmlunit.html.HtmlInput;
import com.gargoylesoftware.htmlunit.html.HtmlPage;

/**
 * @author asmirnov
 * 
 */
public class RepeaterTest extends AbstractFacesTest {

	@Override
	protected void setupWebContent() {
		facesServer.addResourcesFromDirectory("/", this.getClass().getResource("/repeater.xhtml"));
	}

//	@Override
//	protected void setupSunFaces() {
//	}
	/**
	 * @throws java.lang.Exception
	 */

	@Test
	public void testHelloFacelets() throws Exception {
		WebClient webClient = new LocalWebClient(facesServer,BrowserVersion.FIREFOX_3);
		webClient.setThrowExceptionOnScriptError(true);
		webClient.setAjaxController(new NicelyResynchronizingAjaxController());
		HtmlPage page = webClient.getPage("http://localhost/repeater.jsf");
		page.getEnclosingWindow().getThreadManager().joinAll(10000);
//		System.out.println(page.asXml());
		HtmlForm htmlForm = page.getFormByName("ajaxForm");
		HtmlInput htmlInput = htmlForm.getInputByName("ajaxForm:text");
		assertNotNull(htmlForm);
		htmlInput.setValueAttribute("foo");
		htmlInput.click();
//		System.out.println(page.asXml());
		Element element = page.getElementById("ajaxForm:out");
		assertEquals("foo", element.getTextContent().trim());
	}

}
