package org.richfaces.realworld.fileupload;

import java.io.IOException;
import java.io.OutputStream;

import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.richfaces.event.UploadEvent;
import org.richfaces.model.UploadItem;
import org.richfaces.realworld.domain.User;

@Name("avatarUpload")
public class AvatarUpload {

	@In @Out
	private User user;
	
	@In(create=true)
	private FileManager fileManager;
	
	private FileItem avatarItem;
	
	private boolean autoUpload = false;
	
	public void avatarListener(UploadEvent event){
	    //UploadItem item = event.getUploadItem();
	    //System.out.println("File : '" + item.getFileName() + "' was uploaded");
	    	//try {
	    		UploadItem item = event.getUploadItem();
	    	    FileItem file = new FileItem();
	    	    file.setLength(item.getData().length);
	    	    file.setName(item.getFileName());
	    	    file.setData(item.getData());
	    	    this.setAvatarItem(file);
	    		//fileManager.deleteAllFromDirectory(user.getLogin()+fileManager.getFileSeparator()+"avatars");
				//fileManager.addImage(user.getLogin()+fileManager.getFileSeparator()+normaliseFileName(item.getFileName()), item.getData());
				//user.setAvatarPath(normaliseFileName(item.getFileName()));
			//} catch (Exception e) {
				// TODO: handle exception
				//facesMessages.add("Error during fileUpload");
			//}
	}
	
	public synchronized void paintAvatar(OutputStream stream, Object object) throws IOException {
		stream.write(this.getAvatarItem().getData());
	}
	public boolean isAutoUpload() {
		return autoUpload;
	}

	public void setAutoUpload(boolean autoUpload) {
		this.autoUpload = autoUpload;
	}

	public FileItem getAvatarItem() {
		return avatarItem;
	}

	public void setAvatarItem(FileItem avatarItem) {
		this.avatarItem = avatarItem;
	}
}
