package org.ajax4jsf.bean;

import java.util.ArrayList;
import java.util.List;

import org.richfaces.component.Dropzone;
import org.richfaces.event.DragEvent;
import org.richfaces.event.DropEvent;

/**
 * copied from demo and tailored
 */
public class DnDBean {
    private List<Framework> containerPHP;

    private List<Framework> containerCF;

    private List<Framework> containerDNET;

    private List<Framework> frameworks;

    public DnDBean() {
        initList();
    }

    public List<Framework> getContainerPHP() {
        return containerPHP;
    }

    public List<Framework> getContainerCF() {
        return containerCF;
    }

    public List<Framework> getContainerDNET() {
        return containerDNET;
    }

    public List<Framework> getFrameworks() {
        return frameworks;
    }

    public void moveFramework(Object fm, Object family) {
        List<Framework> target = null;
        if ("PHP".equals(family)) {
            target = containerPHP;
        } else if ("DNET".equals(family)) {
            target = containerDNET;
        } else if ("CF".equals(family)) {
            target = containerCF;
        }

        if (null != target && frameworks.contains(fm)) {
            target.add((Framework) fm);
            frameworks.remove(fm);
        }
    }

    public String reset() {
        initList();
        return null;
    }

    private void initList() {
        frameworks = new ArrayList<Framework>();
        frameworks.add(new Framework("Flexible Ajax", "PHP"));
        frameworks.add(new Framework("ajaxCFC", "CF"));
        frameworks.add(new Framework("AJAXEngine", "DNET"));
        frameworks.add(new Framework("AjaxAC", "PHP"));
        frameworks.add(new Framework("MonoRail", "DNET"));
        frameworks.add(new Framework("wddxAjax", "CF"));
        frameworks.add(new Framework("AJAX AGENT", "PHP"));
        frameworks.add(new Framework("FastPage", "DNET"));
        frameworks.add(new Framework("JSMX", "CF"));
        frameworks.add(new Framework("PAJAJ", "PHP"));
        frameworks.add(new Framework("Symfony", "PHP"));
        frameworks.add(new Framework("PowerWEB", "DNET"));

        containerPHP = new ArrayList<Framework>();
        containerCF = new ArrayList<Framework>();
        containerDNET = new ArrayList<Framework>();
    }

    public void processDropMethod(DropEvent event) {
        Dropzone dropzone = (Dropzone) event.getComponent();
        moveFramework(event.getDragValue(), dropzone.getDropValue());
    }

    public void processDragMethod(DragEvent event) {
        // TODO Auto-generated method stub
    }

    /**
     * Framework
     */
    public static class Framework {
        private String name;

        private String family;

        public Framework(String name, String family) {
            super();
            this.name = name;
            this.family = family;
        }

        public String getFamily() {
            return family;
        }

        public void setFamily(String family) {
            this.family = family;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
    }
}
